diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/PackageParser.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/PackageParser.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/PackageParser.java	2017-09-27 02:07:48.943736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/PackageParser.java	2017-09-21 16:08:36.659826000 +0900
@@ -5152,4 +5407,1279 @@
             this.error = error;
         }
     }
+    //collaboroid
+    private void copyDirectoryAll(File sourceLocation, File targetLoacation) throws IOException{
+        //source is directory
+        if(sourceLocation.isDirectory()){
+            if(!targetLoacation.exists()){
+                targetLoacation.mkdir();
+            }
+            String[] children = sourceLocation.list();
+            for(int i=0; i<children.length; i++){
+                copyDirectoryAll(new File(sourceLocation, children[i]), new File(targetLoacation, children[i]));
+            }
+        }
+        else{
+            InputStream in = new FileInputStream(sourceLocation);
+            OutputStream out = new FileOutputStream(targetLoacation);
+            //Copy the bits from instream to outstream
+            byte[] buf = new byte[1024];
+            int len;
+            while ((len = in.read(buf)) > 0) {
+                out.write(buf, 0, len);
+            }
+            in.close();
+            out.close();
+
+        }
+    }
+    public void moveFile(File sourceLocation, File targetLoacation, String activityName){
+        try {
+            copyDirectoryPartial(sourceLocation, targetLoacation, activityName);
+        } catch (IOException e) {
+            e.printStackTrace();
+        }
+
+    }
+    public void moveFileAll(File sourceLocation, File targetLoacation){
+        try {
+            copyDirectoryAll(sourceLocation, targetLoacation);
+        } catch (IOException e) {
+            e.printStackTrace();
+        }
+    }
+    private void copyDirectoryPartial(File sourceLocation, File targetLoacation, String activityName) throws IOException{
+
+        //source is directory
+        if(sourceLocation.isDirectory()){
+            if(!targetLoacation.exists()){
+                targetLoacation.mkdir();
+            }
+            String[] children = sourceLocation.list();
+            for(int i=0; i<children.length; i++){
+                copyDirectoryPartial(new File(sourceLocation, children[i]), new File(targetLoacation, children[i]), activityName);
+            }
+        }
+
+        else{
+            if(sourceLocation.getName().contains(activityName)) {
+                InputStream in = new FileInputStream(sourceLocation);
+                OutputStream out = new FileOutputStream(targetLoacation);
+
+                //Copy the bits from instream to outstream
+                byte[] buf = new byte[1024];
+                int len;
+                while ((len = in.read(buf)) > 0) {
+                    out.write(buf, 0, len);
+                }
+                in.close();
+                out.close();
+            }
+        }
+    }
+    private void copyFile(InputStream in, OutputStream out) throws IOException {
+        byte[] buffer = new byte[1024];
+        int read;
+        while((read = in.read(buffer)) != -1){
+            out.write(buffer, 0, read);
+        }
+    }
+    public void ValuesCopyAssets(AssetManager assetManager, String appName) {
+        String[] files = null;
+
+        try {
+            files = assetManager.list("collaboroid/values");
+            //이미지만 가져올때 files = assetManager.list("image");
+
+        } catch (IOException e) {
+            Log.e("tag", e.getMessage());
+        }
+        for(int i=0; i<files.length; i++) {
+            InputStream in = null;
+            OutputStream out = null;
+            try {
+                in = assetManager.open("collaboroid/values/"+files[i]);
+                File outFile = new File("/data/collaboroid/preprocess/"+appName+"/res/values/", files[i]);
+                out = new FileOutputStream(outFile);
+
+                copyFile(in, out);
+                in.close();
+                in = null;
+                out.flush();
+                out.close();
+                out = null;
+            } catch(IOException e) {
+                Log.e("tag", "Failed to copy asset file: " + files[i], e);
+            }
+
+        }
+    }
+
+    public void DrawableCopyAssets(AssetManager assetManager, String appName) {
+        String[] files = null;
+
+        try {
+            files = assetManager.list("collaboroid/drawable");
+            //이미지만 가져올때 files = assetManager.list("image");
+
+        } catch (IOException e) {
+            Log.e("tag", e.getMessage());
+        }
+        for(int i=0; i<files.length; i++) {
+            InputStream in = null;
+            OutputStream out = null;
+            try {
+                in = assetManager.open("collaboroid/drawable/"+files[i]);
+                if(files[i].contains("ic_launcher")){
+                    File outFile = new File("/data/collaboroid/preprocess/"+appName+"/res/drawable/", files[i]);
+                    out = new FileOutputStream(outFile);
+                }else{
+                    File outFile = new File("/data/collaboroid/preprocess/"+appName+"/assets/", files[i]);
+                    out = new FileOutputStream(outFile);
+                }
+                copyFile(in, out);
+                in.close();
+                in = null;
+                out.flush();
+                out.close();
+                out = null;
+            } catch(IOException e) {
+                Log.e("tag", "Failed to copy asset file: " + files[i], e);
+            }
+
+        }
+    }
+    public void LayoutCopyAssets(AssetManager assetManager, String appName) {
+        String[] files = null;
+
+        try {
+            files = assetManager.list("collaboroid/layout");
+            //이미지만 가져올때 files = assetManager.list("image");
+
+        } catch (IOException e) {
+            Log.e("tag", e.getMessage());
+        }
+        for(int i=0; i<files.length; i++) {
+            InputStream in = null;
+            OutputStream out = null;
+            try {
+                in = assetManager.open("collaboroid/layout/"+files[i]);
+                File outFile = new File("/data/collaboroid/preprocess/"+appName+"/res/layout/", files[i]);
+                out = new FileOutputStream(outFile);
+                copyFile(in, out);
+                in.close();
+                in = null;
+                out.flush();
+                out.close();
+                out = null;
+            } catch(IOException e) {
+                Log.e("tag", "Failed to copy asset file: " + files[i], e);
+            }
+
+        }
+    }
+    //reviseapp
+    private void makeReviseDir(String appName){
+
+        String permission="777";
+
+        String basePath = "/reviseApp";
+        String appPath = basePath+"/"+appName;
+        String Smalis = appPath + "/smalis";
+        String dexes = appPath + "/dexes";
+
+        String[] pathLoop = {basePath, appPath, Smalis, dexes};
+
+        for(int i=0; i<pathLoop.length; i++){
+            File fileTemp = new File(pathLoop[i]);
+            if(!fileTemp.exists()){
+                fileTemp.mkdir();
+            }
+            try {
+                String command = "chmod " + permission + " " + pathLoop[i];
+                Runtime runtime = Runtime.getRuntime();
+                runtime.exec(command);
+            } catch (IOException e) {
+                e.printStackTrace();
+            }
+        }
+    }
+    //collaboroid
+    private void makeDir(String appName){
+
+        String permission="777";
+
+        String basePath = "/data/collaboroid";
+        String preBasePath = basePath + "/preprocess";
+        String appPath = preBasePath+"/"+appName;
+        String originalSmali = appPath + "/originalSmali";
+        String modifiedSmaliDummy1 = appPath + "/modifiedSmaliDummy1";
+        String modifiedSmaliDummy2 = appPath + "/modifiedSmaliDummy2";
+        String BaksmaliFolder = appPath + "/baksmaliFolder";
+        String SmaliFolder = appPath + "/smaliFolder";
+        String com = SmaliFolder + "/com";
+        String assets = appPath + "/assets";
+        String res = appPath + "/res";
+        String drawable = res + "/drawable";
+        String drawablemdpi = res + "/drawable-mdpi";
+        String drawablehdpi = res + "/drawable-hdpi";
+        String drawablexhdpi = res + "/drawable-xhdpi";
+        String drawablexxhdpi = res + "/drawable-xxhdpi";
+        String layout = res + "/layout";
+        String values = res + "/values";
+        String dex = appPath + "/dex";
+        String collaboroid = com + "/collaboroid";
+        String dummy1 = collaboroid + "/dummy1";
+        String dummy2 = collaboroid + "/dummy2";
+
+
+        String[] pathLoop = {basePath, preBasePath, appPath, originalSmali, modifiedSmaliDummy1,
+                modifiedSmaliDummy2, BaksmaliFolder, SmaliFolder, assets, res, drawable,drawablemdpi ,
+                drawablehdpi, drawablexhdpi, drawablexxhdpi, layout, values, dex, com,
+                collaboroid, dummy1, dummy2};
+
+        for(int i=0; i<pathLoop.length; i++){
+            File fileTemp = new File(pathLoop[i]);
+            if(!fileTemp.exists()){
+                fileTemp.mkdir();
+            }
+            try {
+                String command = "chmod " + permission + " " + pathLoop[i];
+                Runtime runtime = Runtime.getRuntime();
+                runtime.exec(command);
+            } catch (IOException e) {
+                e.printStackTrace();
+            }
+        }
+    }
+
+    //for Smali file include $1,$2 ... to catch with them
+    private String[] getFileList(String directory, final String pattern){
+        File dir = new File(directory);
+        String fileList[] = dir.list(new FilenameFilter() {
+            @Override
+            public boolean accept(File dir, String name) {
+                return name.startsWith(pattern);
+            }
+        });
+        return fileList;
+    }
+    public List<String> getAll0x7f(String[] sf,String appName){
+        ArrayList<String> resValue = new ArrayList<String>();
+        for(String s : sf){
+            String fileName = "/data/collaboroid/preprocess/"+appName+"/originalSmali/" + s;
+            BufferedReader br = null;
+
+            try {
+                br = new BufferedReader(new FileReader(fileName));
+                String line;
+
+                while ((line = br.readLine()) != null) {
+                    if(line.contains("0x7f")){
+                        String lastWord = line.replaceAll("^.*?(\\w+)\\W*$", "$1");
+                        resValue.add(lastWord);
+                    }
+                }
+            } catch (Exception e) {
+                System.out.println("ERROROROROROROROR:" );
+                return null;
+            } finally {
+                try {
+                    if (br != null)
+                        br.close();
+                } catch (IOException e) {
+                    //
+                }
+            }
+        }
+
+        return resValue;
+    }
+    private String getResNameOrID(int _resInt, AssetManager am, Resources res){
+        String resValue;
+        if((resValue = am.getResourceText2(_resInt).toString()).equalsIgnoreCase("false")){
+            //여기는 false일때. 들어온다. 즉, getResourceText2에. 없으니까. getResourceEntryName로. 가져온다.
+            resValue = res.getResourceEntryName(_resInt);
+        }
+        return resValue;
+    }
+    //HC
+    public HashMap<String, List<String>> replaceContentOfActivity(List<String> oriResInt, List<String> newResStr){
+
+        HashMap<String, String> listOfSubs = new HashMap<String, String>();
+        for(int i = 0;i<oriResInt.size();i++){
+            listOfSubs.put(oriResInt.get(i),newResStr.get(i));
+        }
+
+        //collaboroid
+        List<String> resources = new ArrayList<>();
+
+        String smaliFileList[] = smali$FileList.get(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+
+        for(int i=0; i<smaliFileList.length; i++){
+            if(smaliFileList[i].contains("$")){
+
+                String SMALIoldFileName = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/originalSmali/"+smaliFileList[i];
+                String SMALItmpFileDummy1Name = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/modifiedSmaliDummy1/"+smaliFileList[i];
+                String SMALItmpFileDummy2Name = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/modifiedSmaliDummy2/"+smaliFileList[i];
+
+                BufferedReader br1 = null;
+                BufferedWriter bw1 = null;
+                BufferedWriter bw2 = null;
+                try {
+                    System.out.println(SMALIoldFileName);
+                    br1 = new BufferedReader(new FileReader(SMALIoldFileName));
+                    bw1 = new BufferedWriter(new FileWriter(SMALItmpFileDummy1Name));
+                    bw2 = new BufferedWriter(new FileWriter(SMALItmpFileDummy2Name));
+
+                    String lineDummy1;
+                    String lineDummy2;
+                    String tempPackageName = CURRENT_AGENT_PACKAGE.replace(".","/");
+
+                    while ((lineDummy2 = br1.readLine()) != null) {
+                        //SBJ
+                        // (?i) <- "찾을 문자열"에 대소문자 구분을 없애고
+                        // .*   <- 문자열이 행의 어디에 있든지 찾을 수 있게
+                        lineDummy1 = lineDummy2;
+                        if(lineDummy2.matches("(?i).*" + tempPackageName + "/" + CURRENT_AGENT_ACTIVITY + ".*")){
+                            lineDummy1 = lineDummy1.replace(tempPackageName + "/" + CURRENT_AGENT_ACTIVITY , "com/collaboroid/dummy1/MainActivity");
+                            lineDummy2 = lineDummy2.replace(tempPackageName + "/" + CURRENT_AGENT_ACTIVITY , "com/collaboroid/dummy2/MainActivity");
+
+                        }
+                        if(lineDummy2.contains(CURRENT_AGENT_ACTIVITY+".java")){
+                            lineDummy1 = lineDummy1.replace(CURRENT_AGENT_ACTIVITY+".java" , "MainActivity.java");
+                            lineDummy2 = lineDummy2.replace(CURRENT_AGENT_ACTIVITY+".java" , "MainActivity.java");
+                        }
+                        bw1.write(lineDummy1);
+                        bw1.newLine();
+                        bw2.write(lineDummy2);
+                        bw2.newLine();
+                    }
+                } catch (Exception e) {
+                    return null;
+                } finally {
+                    try {
+                        if (br1 != null)
+                            br1.close();
+                    } catch (IOException e) {
+                        //
+                    }
+                    try {
+                        if (bw1 != null)
+                            bw1.close();
+                    } catch (IOException e) {
+                        //
+                    }
+                    try {
+                        if (bw2 != null)
+                            bw2.close();
+                    } catch (IOException e) {
+                        //
+                    }
+                }
+            }else{
+                String oldFileName = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/originalSmali/"+ smaliFileList[i];
+                String tmpFileDummy1Name = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/modifiedSmaliDummy1/"+ smaliFileList[i];
+                String tmpFileDummy2Name = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/modifiedSmaliDummy2/"+ smaliFileList[i];
+
+
+                BufferedReader br = null;
+                BufferedWriter bw1 = null;
+                BufferedWriter bw2 = null;
+
+                try {
+                    br = new BufferedReader(new FileReader(oldFileName));
+                    bw1 = new BufferedWriter(new FileWriter(tmpFileDummy1Name));
+                    bw2 = new BufferedWriter(new FileWriter(tmpFileDummy2Name));
+                    String lineDummy1;
+                    String lineDummy2;
+
+                    while ((lineDummy2 = br.readLine()) != null) {
+                        lineDummy1 = lineDummy2;
+                        String tempPackageName = CURRENT_AGENT_PACKAGE.replace(".","/");
+                        if(lineDummy2.matches("(?i).*" + tempPackageName + "/" + CURRENT_AGENT_ACTIVITY + ".*")){
+                            lineDummy1 = lineDummy1.replace(tempPackageName + "/" + CURRENT_AGENT_ACTIVITY , "com/collaboroid/dummy1/MainActivity");
+                            lineDummy2 = lineDummy2.replace(tempPackageName + "/" + CURRENT_AGENT_ACTIVITY , "com/collaboroid/dummy2/MainActivity");
+                        }
+                        if(lineDummy2.contains(CURRENT_AGENT_ACTIVITY+".java")){
+                            lineDummy1 = lineDummy1.replace(CURRENT_AGENT_ACTIVITY+".java" , "MainActivity.java");
+                            lineDummy2 = lineDummy2.replace(CURRENT_AGENT_ACTIVITY+".java" , "MainActivity.java");
+                        }
+
+
+                        //HC
+                        if(lineDummy2.contains("0x7f03")){
+                            String firstWord = lineDummy2.substring(4,lineDummy2.length()).split(" ", 2)[0];
+                            lineDummy1 = lineDummy1.replace(firstWord, "const-string/jumbo");
+                            lineDummy2 = lineDummy2.replace(firstWord, "const-string/jumbo");
+                            String lastWord = lineDummy2.replaceAll("^.*?(\\w+)\\W*$", "$1");
+                            String path_to_res = listOfSubs.get(lastWord);
+                            lineDummy1 = lineDummy1.replace(lastWord, "\"" + path_to_res + "\"");
+                            lineDummy2 = lineDummy2.replace(lastWord, "\"" + path_to_res + "\"");
+                            //add resourceTable
+                            if(path_to_res.contains("xml")){
+                                resources.add(path_to_res);
+                                List<String> temp = relateResourceXML(path_to_res);
+                                Log.d("SBJSBJ path_to_res", "SBJSBJ path_to_res : " + path_to_res);
+                                resources.addAll(temp);
+                            }
+                        }
+                        else if(lineDummy2.contains("setContentView")){
+                            lineDummy1 = lineDummy1.replace("setContentView", "setContentView2");
+                            lineDummy2 = lineDummy2.replace("setContentView", "setContentView2");
+                            lineDummy1 = lineDummy1.replace("(I)", "(Ljava/lang/String;)");
+                            lineDummy2 = lineDummy2.replace("(I)", "(Ljava/lang/String;)");
+                        }
+                        else if(lineDummy2.contains("0x7f")){
+                            String firstWord = lineDummy2.substring(4,lineDummy2.length()).split(" ", 2)[0];
+                            lineDummy1 = lineDummy1.replace(firstWord, "const-string/jumbo");
+                            lineDummy2 = lineDummy2.replace(firstWord, "const-string/jumbo");
+                            String lastWord = lineDummy2.replaceAll("^.*?(\\w+)\\W*$", "$1");
+                            String path_to_res = listOfSubs.get(lastWord);
+                            lineDummy1 = lineDummy1.replace(lastWord, "\"" + path_to_res + "\"");
+                            lineDummy2 = lineDummy2.replace(lastWord, "\"" + path_to_res + "\"");
+                            /*
+                            if(path_to_res.contains("png")){
+                                // ** res/layout/activity_player.xml
+                                // ** res/drawable/back.png
+                                resources.add(path_to_res);
+                                Log.d("SBJSBJ path_to_res", "SBJSBJ path_to_res : " + path_to_res);
+                            }
+                            */
+                        }
+                        else if(lineDummy2.contains("findViewById")){
+                            lineDummy1 = lineDummy1.replace("(I)", "(Ljava/lang/String;)");
+                            lineDummy2 = lineDummy2.replace("(I)", "(Ljava/lang/String;)");
+                        }else if(lineDummy2.contains("setImageResource")){
+                            lineDummy1 = lineDummy1.replace("(I)", "(Ljava/lang/String;)");
+                            lineDummy2 = lineDummy2.replace("(I)", "(Ljava/lang/String;)");
+                        }
+
+                        bw1.write(lineDummy1);
+                        bw1.newLine();
+
+                        bw2.write(lineDummy2);
+                        bw2.newLine();
+                    }
+                } catch (Exception e) {
+                    return null;
+                } finally {
+                    try {
+                        if (br != null)
+                            br.close();
+                    } catch (IOException e) {
+                        //
+                    }
+                    try {
+                        if (bw1 != null)
+                            bw1.close();
+                    } catch (IOException e) {
+                        //
+                    }
+                    try {
+                        if (bw2 != null)
+                            bw2.close();
+                    } catch (IOException e) {
+                        //
+                    }
+                }
+            }
+        }
+
+        for(int i=0; i<smaliFileList.length; i++) {
+            String SMALIoldFileName = "/data/collaboroid/preprocess/"
+                    + CURRENT_AGENT_APP + "/originalSmali/" + smaliFileList[i];
+            try {
+                System.out.println(SMALIoldFileName);
+
+                File sourceFile = new File(SMALIoldFileName);
+                BufferedReader reversedLineInputStream = new BufferedReader(new InputStreamReader(new ReverseLineInputStream(sourceFile)));
+                String line;
+                while ((line = reversedLineInputStream.readLine()) != null) {
+                    if (line.contains("setImageResource(Ljava/lang/String;)V")) {
+                        String lookingForString = "";
+                        String AnswerForString = "";
+                        lookingForString = line.substring(4, line.lastIndexOf(",")).trim().split(",")[1];
+                        System.out.println("lookingForString : " + lookingForString);
+                        if (lookingForString.contains("}")) {
+                            lookingForString = lookingForString.trim().split("\\}")[0];
+                        }
+                        while (true) {
+                            String l = reversedLineInputStream.readLine();
+                            if (l.contains(lookingForString)) {
+                                if(l.contains("const-string/jumbo")){
+                                    AnswerForString = l.split(",", 2)[1];
+                                    AnswerForString = AnswerForString.substring(0, AnswerForString.length() - 1);
+                                    if (AnswerForString.contains("\"")) {
+                                        AnswerForString = AnswerForString.split("\"", 2)[1];
+                                        //=> "SBJ_C"
+                                        AnswerForString = AnswerForString.substring(0, AnswerForString.length());
+                                        // add
+                                        resources.add("assets/"+AnswerForString);
+                                        break;
+                                    }
+                                }else {
+                                    break;
+                                    //lookingForString = l.split(",", 2)[1];
+                                }
+                            }
+                        }
+
+                    }
+                }
+
+            }catch (Exception e){
+                e.printStackTrace();
+            }
+        }
+
+        //duplicate remove
+        HashSet hs = new HashSet(resources);
+        List<String> newResources = new ArrayList<>(hs);
+
+        HashMap<String, List<String>> relatedResources = new HashMap<>();
+        relatedResources.put(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY, newResources);
+
+        return relatedResources;
+    }
+
+    private void DeleteRecursiveFiles(File fileOrDirectory) {
+
+        if (fileOrDirectory.isDirectory())
+            for (File child : fileOrDirectory.listFiles())
+                DeleteRecursive(child);
+
+    }
+    private void DeleteRecursive(File fileOrDirectory) {
+
+        if (fileOrDirectory.isDirectory())
+            for (File child : fileOrDirectory.listFiles())
+                DeleteRecursive(child);
+
+        fileOrDirectory.delete();
+
+    }
+    private void PermissionRecursiveFiles(File fileOrDirectory) {
+
+        if (fileOrDirectory.isDirectory())
+            for (File child : fileOrDirectory.listFiles())
+                PermissionRecursive(child);
+
+    }
+    private void PermissionRecursive(File fileOrDirectory) {
+
+        if (fileOrDirectory.isDirectory())
+            for (File child : fileOrDirectory.listFiles())
+                PermissionRecursive(child);
+
+        try {
+            // get the object of runtime
+            Runtime rt = Runtime.getRuntime();
+            Process m ;
+            int c=0;
+            String command = "chmod " + 777 + " " + fileOrDirectory.getPath();
+            m = rt.exec(command);
+            InputStream bis = new BufferedInputStream(m.getInputStream());
+            while(c!=-1) {
+                c=bis.read();
+                //printing something on console
+                System.out.print("#");
+            }// this while loop executes till the batch file ends executing
+            m = null;
+            bis.close();
+        } catch (Exception exe) {
+            exe.printStackTrace();
+        }
+
+    }
+    private void renameActivityToMainDummy1(String toSendActivity){
+
+        BufferedReader br1 = null;
+        BufferedWriter bw1 = null;
+
+
+        String smaliFileList[] = smali$FileList.get(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+        for(int i=0; i<smaliFileList.length; i++){
+
+            String SMALIoldFileName = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/modifiedSmaliDummy1/"+smaliFileList[i];
+            //smaliFileList[i] include .smali
+            String SMALInewFileName = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/smaliFolder/com/collaboroid/dummy1/"
+                    +smaliFileList[i].replace(toSendActivity, "MainActivity");
+
+            br1 = null;
+            bw1 = null;
+            try {
+                br1 = new BufferedReader(new FileReader(SMALIoldFileName));
+                bw1 = new BufferedWriter(new FileWriter(SMALInewFileName));
+                String line;
+
+                while ((line = br1.readLine()) != null) {
+                    bw1.write(line);
+                    bw1.newLine();
+                }
+            } catch (Exception e) {
+                return;
+            } finally {
+                try {
+                    if (br1 != null)
+                        br1.close();
+                } catch (IOException e) {
+                    //
+                }
+                try {
+                    if (bw1 != null)
+                        bw1.close();
+                } catch (IOException e) {
+                    //
+                }
+            }
+        }
+    }
+    private void renameActivityToMainDummy2(String toSendActivity){
+
+        BufferedReader br1 = null;
+        BufferedWriter bw1 = null;
+
+
+        String smaliFileList[] = smali$FileList.get(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+        for(int i=0; i<smaliFileList.length; i++){
+
+            String SMALIoldFileName = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/modifiedSmaliDummy2/"+smaliFileList[i];
+            //smaliFileList[i] include .smali
+            String SMALInewFileName = "/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/smaliFolder/com/collaboroid/dummy2/"
+                    +smaliFileList[i].replace(toSendActivity, "MainActivity");
+            br1 = null;
+            bw1 = null;
+            try {
+                br1 = new BufferedReader(new FileReader(SMALIoldFileName));
+                bw1 = new BufferedWriter(new FileWriter(SMALInewFileName));
+                String line;
+
+                while ((line = br1.readLine()) != null) {
+                    bw1.write(line);
+                    bw1.newLine();
+                }
+            } catch (Exception e) {
+                return;
+            } finally {
+                try {
+                    if (br1 != null)
+                        br1.close();
+                } catch (IOException e) {
+                    //
+                }
+                try {
+                    if (bw1 != null)
+                        bw1.close();
+                } catch (IOException e) {
+                    //
+                }
+            }
+        }
+    }
+    public class Decompress {
+        private String _zipFile;  //저장된 zip 파일 위치
+        private String _location; //압출을 풀 위치
+
+        public Decompress(String zipFile, String location) {
+            _zipFile = zipFile;
+            _location = location;
+
+            _dirChecker(""); //폴더를 만들기 위한 함수로 아래에 정의 되어 있습니다.
+        }
+
+        public void unzip() {
+            try  {
+                FileInputStream fin = new FileInputStream(_zipFile);
+                ZipInputStream zin = new ZipInputStream(fin);
+                ZipEntry ze = null;
+                while ((ze = zin.getNextEntry()) != null) {
+                    Log.v("Decompress", "Unzipping " + ze.getName());   //압축이 풀리면서 logcat으로 zip 안에 있던 파일들을 볼 수 있습니다.
+
+                    if(ze.isDirectory()) {
+                        _dirChecker(ze.getName());
+                    } else {
+                        FileOutputStream fout = new FileOutputStream(_location + ze.getName());
+                        BufferedInputStream in = new BufferedInputStream(zin);  //이렇게 지정하지 않고 unzip을 수행하면 속도가 매우 느려집니다.
+                        BufferedOutputStream out = new BufferedOutputStream(fout);
+                        byte b[] = new byte[1024];
+                        int n;
+                        while ((n = in.read(b,0,1024)) >= 0) {
+                            out.write(b,0,n);
+                        }
+
+                        zin.closeEntry();
+                        fout.close();
+                    }
+
+                }
+                zin.close();
+            } catch(Exception e) {
+                Log.e("Decompress", "unzip", e);
+            }
+        }
+
+        //변수 location에 저장된 directory의 폴더를 만듭니다.
+        private void _dirChecker(String dir) {
+            File f = new File(_location + dir);
+
+            if(!f.isDirectory()) {
+                f.mkdirs();
+            }
+        }
+    }
+    private void copyAndRename(String apkPath, String zipPath){
+        File sourceLocation = new File (apkPath);
+        File targetLocation = new File (zipPath);
+        Log.v(TAG, "sourceLocation: " + sourceLocation);
+        Log.v(TAG, "targetLocation: " + targetLocation);
+        try {
+            int actionChoice = 2;
+            if(actionChoice==1){
+                if(sourceLocation.renameTo(targetLocation)){
+                    Log.v(TAG, "Move file successful.");
+                }else{
+                    Log.v(TAG, "Move file failed.");
+                }
+            }
+            else{
+                if(sourceLocation.exists()){
+                    InputStream in = new FileInputStream(sourceLocation);
+                    OutputStream out = new FileOutputStream(targetLocation);
+                    byte[] buf = new byte[1024];
+                    int len;
+                    while ((len = in.read(buf)) > 0) {
+                        out.write(buf, 0, len);
+                    }
+                    in.close();
+                    out.close();
+                    Log.v(TAG, "Copy file successful.");
+                }else{
+                    Log.v(TAG, "Copy file failed. Source file missing.");
+                }
+            }
+        } catch (NullPointerException e) {
+            e.printStackTrace();
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+    }
+
+    public void makeActivityTable(String[] srcList)
+    {
+        List<String> resultOnCreate = new ArrayList<>();
+        List<String> AllActivity = new ArrayList<>();
+        List<String> forActivity = new ArrayList<>();
+        List<String> onCreateMethodTemp;
+
+        //private HashMap<String, HashMap<String, List<String>>> ActivityTable = new HashMap<>();
+        //1.appName     2.packageName + MainActivityName ------- related activity
+        List<String> activities = new ArrayList<>();
+        HashMap<String, List<String>> mainActivity = new HashMap<>();
+
+        for(int j=0; j<srcList.length; j++){
+
+            //File sourceFile = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/originalSmali/"+srcList[j]);
+            File sourceFile = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/originalSmali/"+srcList[j]);
+            try {
+                BufferedReader reversedLineInputStream = new BufferedReader(new InputStreamReader(new ReverseLineInputStream(sourceFile)));
+//            ReversedLinesFileReader reversedLinesFileReader = new ReversedLinesFileReader(new File(oldFileName));
+                String line;
+                while ((line = reversedLineInputStream.readLine()) != null) {
+                    String lookingForString = "";
+                    String AnswerForString = "";
+                    if (line.contains(".end method")) {
+                        onCreateMethodTemp = new ArrayList<>();
+                        boolean result = false;
+                        boolean loopResult = false;
+                        String gotoName = "no";
+                        while (true) {
+                            line = reversedLineInputStream.readLine();
+                            if (line.contains("goto") && !loopResult) {
+                                gotoName = line.trim().split(":")[1];
+                                line = reversedLineInputStream.readLine();
+                                line = reversedLineInputStream.readLine();
+                                if(line.contains("add-int/lit8")){
+                                    loopResult = true;
+                                }
+
+
+                                // find for loop
+                            }
+                            if (line.contains("launchActivity(Ljava/lang/String;)V")) {
+                                lookingForString = line.substring(4, line.lastIndexOf(",")).trim().split(",")[1];
+                                if (lookingForString.contains("}")) {
+                                    lookingForString = lookingForString.trim().split("\\}")[0];
+                                }
+                                while (true) {
+                                    String l = reversedLineInputStream.readLine();
+                                    if (l.contains(lookingForString)) {
+                                        AnswerForString = l.split(",", 2)[1];
+                                        AnswerForString = AnswerForString.substring(0, AnswerForString.length() - 1);
+                                        if (AnswerForString.contains("\"")) {
+                                            AnswerForString = AnswerForString.split("\"", 2)[1];
+                                            AnswerForString = AnswerForString.substring(0, AnswerForString.length());
+                                            // add
+                                            result = true;
+                                            onCreateMethodTemp.add(AnswerForString);
+                                            AllActivity.add(AnswerForString);
+                                            break;
+                                        } else {
+                                            lookingForString = l.split(",", 2)[1];
+                                        }
+                                    }
+                                }
+                            }
+                            if (line.contains("launchActivity(ILjava/lang/String;)V")) {
+
+                                lookingForString = line.substring(4, line.lastIndexOf(",")).trim().split(",")[2];
+                                if (lookingForString.contains("}")) {
+                                    lookingForString = lookingForString.trim().split("\\}")[0];
+                                }
+                                while (true) {
+                                    String l = reversedLineInputStream.readLine();
+                                    if (l.contains(lookingForString)) {
+                                        AnswerForString = l.split(",", 2)[1];
+                                        AnswerForString = AnswerForString.substring(0, AnswerForString.length() - 1);
+                                        if (AnswerForString.contains("\"")) {
+                                            AnswerForString = AnswerForString.split("\"", 2)[1];
+                                            AnswerForString = AnswerForString.substring(0, AnswerForString.length());
+                                            // add
+                                            result = true;
+                                            onCreateMethodTemp.add(AnswerForString);
+
+                                            AllActivity.add(AnswerForString);
+                                            break;
+                                        } else {
+                                            lookingForString = l.split(",", 2)[1];
+                                        }
+                                    }
+                                }
+                            }
+                            if (line.contains("launchActivity(ILjava/lang/String;Landroid/os/Bundle;)V")) {
+
+                                lookingForString = line.substring(4, line.lastIndexOf(",")).trim().split(",")[2];
+                                if (lookingForString.contains("}")) {
+                                    lookingForString = lookingForString.trim().split("\\}")[0];
+                                }
+                                while (true) {
+                                    String l = reversedLineInputStream.readLine();
+                                    if (l.contains(lookingForString)) {
+                                        AnswerForString = l.split(",", 2)[1];
+                                        AnswerForString = AnswerForString.substring(0, AnswerForString.length() - 1);
+                                        if (AnswerForString.contains("\"")) {
+                                            AnswerForString = AnswerForString.split("\"", 2)[1];
+                                            AnswerForString = AnswerForString.substring(0, AnswerForString.length());
+                                            // add
+                                            result = true;
+                                            onCreateMethodTemp.add(AnswerForString);
+
+                                            AllActivity.add(AnswerForString);
+                                            break;
+                                        } else {
+                                            lookingForString = l.split(",", 2)[1];
+                                        }
+                                    }
+                                }
+                            }
+                            if (line.contains("launchActivity(Ljava/lang/String;Landroid/os/Bundle;)V")) {
+                                lookingForString = line.substring(4, line.lastIndexOf(",")).trim().split(",")[1];
+                                if (lookingForString.contains("}")) {
+                                    lookingForString = lookingForString.trim().split("\\}")[0];
+                                }
+                                while (true) {
+                                    String l = reversedLineInputStream.readLine();
+                                    // System.out.println("l : " + l);
+                                    if (l.contains(lookingForString)) {
+                                        // System.out.println("ll : " + l);
+                                        AnswerForString = l.split(",", 2)[1];
+                                        AnswerForString = AnswerForString.substring(0, AnswerForString.length() - 1);
+                                        if (AnswerForString.contains("\"")) {
+                                            AnswerForString = AnswerForString.split("\"", 2)[1];
+                                            AnswerForString = AnswerForString.substring(0, AnswerForString.length());
+                                            // add
+                                            result = true;
+                                            onCreateMethodTemp.add(AnswerForString);
+                                            AllActivity.add(AnswerForString);
+                                            break;
+                                        } else {
+                                            lookingForString = l.split(",", 2)[1];
+                                        }
+                                    }
+                                }
+                            }
+                            if (!gotoName.equals("no") && line.contains(gotoName) && loopResult && result) {
+                                //for loop * 10
+                                List<String> temp = new ArrayList<>();
+
+                                for(int z=0; z<onCreateMethodTemp.size(); z++){
+                                    temp.add(onCreateMethodTemp.get(z));
+                                }
+
+                                for(int z=0; z<10; z++){
+                                    forActivity.addAll(temp);
+                                }
+                            }
+                            if (line.contains(".method")) {
+                                if (result) {
+                                    // if onCreate
+                                    // 중복제거
+
+                                    HashSet hs = new HashSet(onCreateMethodTemp);
+                                    onCreateMethodTemp = new ArrayList<>(hs);
+                                    if (line.contains("onCreate")) {
+                                        resultOnCreate.addAll(onCreateMethodTemp);
+                                    } // if onClick
+                                    else if (line.contains("onClick")) {
+                                    } else {
+                                        String s = search(srcList, line.trim().split(" ")[2]);
+                                        String split_temp[] = s.trim().split("@");
+                                        for (int split_i = 0; split_i < split_temp.length; split_i++) {
+                                            if (split_temp[split_i].contains("onCreate")) {
+                                                for (int z = 0; z < onCreateMethodTemp.size(); z++) {
+                                                    onCreateMethodTemp.set(z, onCreateMethodTemp.get(z) + "@"
+                                                            + split_temp[split_i].trim().split("<-")[0]);
+                                                }
+                                                resultOnCreate.addAll(onCreateMethodTemp);
+                                            }
+                                        }
+
+                                    }
+                                    // if onClick && for
+                                }
+                                break;
+                            }
+                        }
+                    }
+                }
+            } catch (IOException e) {
+                e.printStackTrace();
+            }
+        }
+
+
+        //17.07.23
+
+        ArrayList<MethodLineNode> list = new ArrayList<>();
+        for (int i = 0; i < resultOnCreate.size(); i++) {
+            if(resultOnCreate.get(i).contains("@")){
+                MethodLineNode node = new MethodLineNode(orderScore(srcList, resultOnCreate.get(i).trim().split("@")[1]),
+                        resultOnCreate.get(i).trim().split("@")[0]);
+                list.add(node);
+            }else{
+                MethodLineNode node = new MethodLineNode(orderScore(srcList, resultOnCreate.get(i)),
+                        resultOnCreate.get(i));
+                list.add(node);
+            }
+        }
+
+
+
+        Collections.sort(list);
+
+        for(int i=0; i<list.size(); i++){
+            Log.d("search test","list : " + list.get(i).getLineNum() + " / "+ list.get(i).getMethodName());
+        }
+
+        HashMap<String, Double> scoreMap = new HashMap<>();
+        //ScoreMap scoremap = new ScoreMap(0.0);
+        AllActivity.addAll(forActivity);
+        for(int i=0; i<AllActivity.size(); i++){
+            Double value = 0.0;
+            if(scoreMap.containsKey(AllActivity.get(i))){
+                value = scoreMap.get(AllActivity.get(i));
+            }else{
+                value = 0.0;
+            }
+            scoreMap.put(AllActivity.get(i), value + 0.001);
+        }
+        for(int i=0; i<list.size(); i++){
+            Double value = 0.0;
+            if(scoreMap.containsKey(list.get(i).getMethodName())){
+                value = scoreMap.get(list.get(i).getMethodName());
+            }else{
+                value = 0.0;
+            }
+            scoreMap.put(list.get(i).getMethodName(),
+                    value + (i + 1.0));
+        }
+
+
+        //TreeMap<String, Double> tm = new TreeMap<String, Double>(scoreMap);
+        //Iterator<String> iteratorKey = tm.keySet().iterator();   //키값 오름차순 정렬(기본)
+        List<String> newActivities = new ArrayList<>();
+
+        Iterator it = sortByValue(scoreMap).iterator();
+
+        while(it.hasNext()) {
+            String temp = (String) it.next();
+            System.out.println(temp + " = " + scoreMap.get(temp));
+            newActivities.add(temp);
+        }
+
+
+
+        mainActivity.put(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY, newActivities);
+        ActivityTable.put(CURRENT_AGENT_APP, mainActivity);
+    }
+    //별도의 스태틱 함수로 구현
+    public List sortByValue(final Map map) {
+        List<String> list = new ArrayList();
+        list.addAll(map.keySet());
+
+        Collections.sort(list,new Comparator() {
+
+            public int compare(Object o1,Object o2) {
+                Object v1 = map.get(o1);
+                Object v2 = map.get(o2);
+
+                return ((Comparable) v2).compareTo(v1);
+            }
+
+        });
+        //Collections.reverse(list); // 주석시 오름차순
+        return list;
+    }
+    public int orderScore(String[] srcList, String target) {
+        for (int i = 0; i < srcList.length; i++) {
+            File sourceFile = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/originalSmali/"+srcList[i]);
+            try {
+
+                BufferedReader lineInputStream = new BufferedReader(new FileReader(sourceFile));
+                String line;
+                while ((line = lineInputStream.readLine()) != null) {
+                    if (line.contains("onCreate(Landroid/os/Bundle;)V")) {
+                        String l;
+                        int result = 0;
+                        while ((l = lineInputStream.readLine()) != null) {
+                            result++;
+                            if (l.contains(target)) {
+                                return result;
+                            }
+                            if (l.contains(".end method")) {
+                                break;
+                            }
+                        }
+                    }
+                }
+            } catch (Exception e) {
+
+            }
+        }
+        return 0;
+    }
+    public String search(String[] srcList, String target) {
+        String result = "";
+        for (int i = 0; i < srcList.length; i++) {
+            // target을 향해 모든 smali 쭈욱
+            File sourceFile = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/originalSmali/"+srcList[i]);
+            try {
+                BufferedReader reversedLineInputStream = new BufferedReader(
+                        new InputStreamReader(new ReverseLineInputStream(sourceFile)));
+                String line;
+                while ((line = reversedLineInputStream.readLine()) != null) {
+                    if (line.contains(".end method")) {
+                        boolean find = false;
+                        String l;
+                        while ((l = reversedLineInputStream.readLine()) != null) {
+
+                            if (l.contains(target) && !l.contains(".method")) {
+                                find = true;
+                            }
+                            if (l.contains(".method")) {
+
+                                if (find) {
+                                    if (l.contains("onCreate")) {
+                                        return "onCreate";
+                                    } else if (l.contains("onClick")) {
+                                        return "onClick";
+                                    } else {
+                                        find = false;
+                                        result += l.trim().split(" ")[2] + "<-"
+                                                + search(srcList, l.trim().split(" ")[2]) + "@";
+                                    }
+                                }
+                            }
+                        }
+                    }
+                }
+            } catch (Exception e) {
+                e.printStackTrace();
+            }
+        }
+        if (result.equals("")) {
+            return "nofunction";
+        } else {
+            return result;
+        }
+    }
+    public void writeActivityTable(List<String> sf){
+        PrintWriter pw = null;
+        BufferedReader lineInputStream = null;
+        File table = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/ActivityTable.txt");
+        if(table.exists()){
+            try{
+                lineInputStream = new BufferedReader(new FileReader(table));
+                String line = "";
+                boolean result = true;
+                while ((line = lineInputStream.readLine()) != null) {
+                    if (line.contains(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY)) {
+                        result = false;
+                    }
+                }
+                if(result){
+                    pw = new PrintWriter(
+                            new FileWriter("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/ActivityTable.txt", true));
+                    pw.write(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+                    for(int i=0; i<sf.size(); i++){
+                        pw.write("@");
+                        pw.write(sf.get(i));
+                    }
+                    pw.write("\n\r");
+                }
+                if(lineInputStream != null){
+                    lineInputStream.close();
+                }
+            }catch (Exception e){
+                e.printStackTrace();
+            }finally{
+                if(pw != null) {
+                    pw.close();
+                }
+            }
+        }else{
+            try {
+                pw = new PrintWriter(
+                        new FileWriter("/data/collaboroid/preprocess/" + CURRENT_AGENT_APP + "/ActivityTable.txt", true));
+                pw.write(CURRENT_AGENT_PACKAGE + "." + CURRENT_AGENT_ACTIVITY);
+                for (int i = 0; i < sf.size(); i++) {
+                    pw.write("@");
+                    pw.write(sf.get(i));
+                }
+                pw.write("\n\r");
+            }catch(Exception e){
+                e.printStackTrace();
+            }finally{
+                if(pw != null) {
+                    pw.close();
+                }
+            }
+        }
+
+
+    }
+    public void writeResourceTable(List<String> sf){
+        PrintWriter pw = null;
+        BufferedReader lineInputStream = null;
+        File table = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/ResourceTable.txt");
+        if(table.exists()){
+            try{
+                lineInputStream = new BufferedReader(new FileReader(table));
+                String line = "";
+                boolean result = true;
+                while ((line = lineInputStream.readLine()) != null) {
+                    if (line.contains(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY)) {
+                        result = false;
+                    }
+                }
+                if(result){
+                    pw = new PrintWriter(
+                            new FileWriter("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/ResourceTable.txt", true));
+                    pw.write(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+                    for(int i=0; i<sf.size(); i++){
+                        pw.write("@");
+                        pw.write(sf.get(i));
+                    }
+                    pw.write("\n\r");
+                }
+                if(lineInputStream != null){
+                    lineInputStream.close();
+                }
+            }catch (Exception e){
+                e.printStackTrace();
+            }finally{
+                if(pw != null) {
+                    pw.close();
+                }
+            }
+        }else{
+            try{
+                pw = new PrintWriter(
+                        new FileWriter("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/ResourceTable.txt", true));
+                pw.write(CURRENT_AGENT_PACKAGE+"."+CURRENT_AGENT_ACTIVITY);
+                for(int i=0; i<sf.size(); i++){
+                    pw.write("@");
+                    pw.write(sf.get(i));
+                }
+                pw.write("\n\r");
+            }catch (Exception e){
+                e.printStackTrace();
+            }finally{
+                if(pw != null) {
+                    pw.close();
+                }
+            }
+        }
+
+    }
+    /**
+     * @hide
+     */
+    public List<String> relateResourceXML(String xmlFilePath){
+        List<String> resources = new ArrayList<>();
+
+        //File file = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/"+xmlFilePath);
+        File file = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/"+xmlFilePath);
+
+        BufferedReader br = null;
+        try {
+            br = new BufferedReader(new FileReader(file));
+            String line;
+            while ((line = br.readLine()) != null) {
+                if(line.contains("drawable")){
+                    String pngFile = line.split("\\/")[1].split("\"")[0];
+                    File inFile = null;
+
+                    File inFilePng = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/assets/", pngFile+".png");
+                    String pngFilePath = "";
+                    if(inFilePng.exists()){
+                        pngFile += ".png";
+                        pngFilePath = "res/drawable/"+pngFile;
+                        inFile = inFilePng;
+                    }
+                    File inFileJpg = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/assets/", pngFile+".jpg");
+                    if(inFileJpg.exists()){
+                        pngFile += ".jpg";
+                        pngFilePath = "res/drawable/"+pngFile;
+                        inFile = inFileJpg;
+                    }
+
+                    File inFileXml = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/assets/", pngFile+".xml");
+                    if(inFileXml.exists()){
+                        pngFile += ".xml";
+                        pngFilePath = "res/drawable/"+pngFile;
+                        inFile = inFileXml;
+                    }
+
+                    FileInputStream in = new FileInputStream(inFile);
+                    //copy resource png file.
+                    File outFile = new File("/data/collaboroid/preprocess/"+CURRENT_AGENT_APP+"/res/drawable/", pngFile);
+                    FileOutputStream out = new FileOutputStream(outFile);
+                    copyFile(in, out);
+
+                    resources.add(pngFilePath);
+                }
+            }
+        } catch (Exception e) {
+            e.printStackTrace();
+        } finally {
+            try {
+                if (br != null)
+                    br.close();
+            } catch (IOException e) {
+                //
+            }
+        }
+        return resources;
+    }
 }
